try:
	import archive_rt
	import carchive_rt
	archive = archive_rt
	carchive = carchive_rt
except:
	exec "from MEInc.Dist import archive"
	exec "from MEInc.Dist import carchive"

class AlienZLibArchive(archive.ZlibArchive):
	def __init__(self,path,start):
		self._startup(path,start)

_ZHDR = ("Pos", "Len", "Pkg", "Name")
def _fmtZToc(toc):
	L=[]
	for k,v in toc.items():
		L.append(v[1:]+(v[0],k))
	L.sort()
	return L

def _getHdr_Toc(name):
	if name[-4:] in ('.pyz', '.PYZ'):
		arch = archive.ZlibArchive(name)
		hdr = _ZHDR
		toc = _fmtZToc(arch.toc)
	else:
		arch = carchive.CArchive(name)
		hdr = ("Pos", "Len", "XLen", "Z", "Type", "Name")
		toc = arch.toc.data
	return hdr, toc, arch

def _printToc(name,(hdr,toc),msg="Contents of"):
	def maxLen( M, T):
		for i in xrange(len(M)):
			M[i] = max(M[i],len(`T[i]`))

	def fmtT( fmt, m, T ):
		fmt += (len(T)-m)*" %s"
		return fmt % tuple(T)

	M = (len(hdr)*[0])[:]
	maxLen(M,hdr)
	for T in toc:
		maxLen(M,T)
	fmt = " "
	M[0] -= 1
	for m in M[:-1]:
		fmt += "%%%ds" % (m+1)
	fmt += " %s"
	m = len(M)
	print msg, name
	print fmtT(fmt,m,hdr)
	for T in toc:
		print fmtT(fmt,m,T)

def printToc(name,recur=0):
	(hdr,toc,arch) = _getHdr_Toc(name)
	_printToc(name,(hdr,toc))
	if recur and hdr[2]=='XLen':
		pkgstart = arch.pkgstart
		del arch
		for T in toc:
			if T[4]=='z':
				stoc = _fmtZToc(AlienZLibArchive(name,start=pkgstart+T[0]).toc)
				_printToc(T[-1],(_ZHDR,stoc),msg="\nSub-contents of")

if __name__=='__main__':
	import sys
	try:
		printToc(sys.argv[1],1)
	except Exception, e:
		print "Exception caught:", `e`, `e.args`
		raw_input("Press any key to continue")
