import sys, os, string
from MEInc.Dist import resource

cfgtmplt = """\
[TK]
type = CARCHIVE
name = tk.pkg
trees = %(base)s
support = 0
installscript = installTK.py
extypes = .lib
expatterns = demos, images
"""

runtmplt = """\
import os
here = sys.path[0]
tcldir = os.path.join(here, 'tk', '%(tcllib)s')
tkdir = os.path.join(here, 'tk', '%(tklib)s')
os.environ["TCL_LIBRARY"] = tcldir
os.environ["TK_LIBRARY"] = tkdir
os.putenv("TCL_LIBRARY", tcldir)
os.putenv("TK_LIBRARY", tkdir)
"""


def main():
    home = os.path.dirname(sys.argv[0])
    print "Finding TK installation..."
    rsrc = resource.makeresource('Tkinter')
    tcllib, tklib = None, None
    for lib in rsrc.binaries:
        if string.lower(lib.name[:3]) == 'tcl' and string.lower(lib.name[-3:]) == 'dll':
            ver = lib.name[3:-4]
            ver = ver[0] + '.' + ver[1:]
            tcllibdir = 'tcl'+ver
            tklibdir = 'tk'+ver
            libin = os.path.dirname(lib.path)
            print "found binaries in", libin
            #first try the Python tcl directory
            base = os.path.join(libin, '../tcl')
            for dirnm in [base, os.path.join(libin, '../lib')]:
                if os.path.exists(os.path.join(dirnm, tcllibdir)):
                    print "found TCL library"
                    tcllib = os.path.join(dirnm, tcllibdir)
                if os.path.exists(os.path.join(dirnm, tklibdir)):
                    print "found TK library"
                    tklib = os.path.join(dirnm, tklibdir)
                if tcllib and tklib:
                    break
            if tcllib and tklib:
                runscript = os.path.join(home, 'projects', 'buildTK', 'runTK.py')
                open(runscript, 'w').write(runtmplt % {'tcllib':tcllibdir,
                                                       'tklib':tklibdir})
                cfgfile = os.path.join(home, 'projects', 'buildTK', 'tk.cfg')
                open(cfgfile, 'w').write(cfgtmplt % {'base': os.path.dirname(tcllib)})
            else:
                print "Could not find TCL and TK's lib directories!"
                print "Operation aborted."
                sys.exit(1)
            break
    else:
        print "Could not find tcl binaries!"
        print "Operation aborted."
        sys.exit(1)

main()
    